Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports['default'] = generateDirectionalStyles;

var _object = require('object.assign');

var _object2 = _interopRequireDefault(_object);

var _rtlCssJs = require('rtl-css-js');

var _rtlCssJs2 = _interopRequireDefault(_rtlCssJs);

var _withRTLExtension = require('./withRTLExtension');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function separateDirectionalStyles(originalStyles, autoRTLStyles) {
  var sharedStyles = {};
  var ltrStyles = (0, _object2['default'])({}, originalStyles);
  var rtlStyles = {};

  var hasRTLStyles = false;
  Object.entries(autoRTLStyles).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    if (value === originalStyles[key]) {
      delete ltrStyles[key];
      sharedStyles[key] = value;
      return;
    }

    if (value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
      delete ltrStyles[key];
      // In some cases (pseudoselectors, matchmedia queries, etc.), the style
      // value may be an object, and we need to recurse.
      var recursiveStyles = separateDirectionalStyles(originalStyles[key], value);

      if (recursiveStyles != null) {
        hasRTLStyles = true;
        var recursiveSharedStyles = recursiveStyles.sharedStyles,
            recursiveLtrStyles = recursiveStyles.ltrStyles,
            recursiveRtlStyles = recursiveStyles.rtlStyles;


        sharedStyles[key] = recursiveSharedStyles;
        ltrStyles[key] = recursiveLtrStyles;
        rtlStyles[key] = recursiveRtlStyles;
      } else {
        sharedStyles[key] = value;
      }
    } else if (value != null) {
      hasRTLStyles = true;
      rtlStyles[key] = value;
    }
  });

  if (!hasRTLStyles) return null;

  return { sharedStyles: sharedStyles, ltrStyles: ltrStyles, rtlStyles: rtlStyles };
}

function generateDirectionalStyles(originalStyles) {
  var _objectAssign2;

  var directionalStyles = separateDirectionalStyles(originalStyles, (0, _rtlCssJs2['default'])(originalStyles));
  if (!directionalStyles) return null;

  var sharedStyles = directionalStyles.sharedStyles,
      ltrStyles = directionalStyles.ltrStyles,
      rtlStyles = directionalStyles.rtlStyles;

  return (0, _object2['default'])({}, sharedStyles, (_objectAssign2 = {}, _defineProperty(_objectAssign2, _withRTLExtension.LTR_SELECTOR, ltrStyles), _defineProperty(_objectAssign2, _withRTLExtension.RTL_SELECTOR, rtlStyles), _objectAssign2));
}